\documentclass{article}

\usepackage{mpi0203}
\usepackage{a4}
\usepackage{epsf}
\usepackage{epic}
\usepackage{eepic}
\usepackage{ecltree}

\title{1 Trabalho Prtico}

\author{
	\mpi{Mtodos de Programao I}
	\\ 
	\lesi{LESI}/\lmcc{LMCC}
	\\ Universidade do Minho
}


\date{Ano Lectivo de 2002/2003}

\begin{document}
\maketitle

\section{Prembulo}

Este trabalho deve ser realizado por grupos com um mximo de trs
alunos. O trabalho deve ser entregue at ao dia \pisca{24 de Outubro 2002} na
Recepo do \dium\ (ext. 4430) e nele deve constar a listagem do cdigo
desenvolvido assim como um pequeno relatrio.

A entrega poder tambm ser feita de forma electrnica,
de acordo com as instrues dos monitores e docentes das aulas prticas.

\section{O problema}
Recorde os seguintes requisitos do 4 Trabalho Prtico da disciplina de
Paradigmas da Programao II, ano lectivo de 2001/02
\footnote{
	Agradece-se aos docentes desta disciplina a disponibilizao
	de material e colaborao neste trabalho.
}:

\begin{quote}\em
\textbf{2.5 Dicionrio}\\
Pretende-se implementar um sistema de manuteno de um dicionrio.
Este ter uma estrutura muito peculiar em memria. Ser construda
uma rvore em que cada nodo ter apenas uma letra da palavra e cada
folha da respectiva rvore ter uma pequena \textit{string} com a
definio de cada palavra inserida.

{\small
\setlength{\GapWidth}{1mm}
\setlength{\GapDepth}{3mm}
\[
\begin{bundle}{dictionary}
  \chunk{\begin{bundle}{a}
      \chunk{\begin{bundle}{b}
          \chunk{
            \begin{bundle}{a}
              \chunk{ABA}
              \chunk{
                \begin{bundle}{l}
                  \chunk{
                    \begin{bundle}{o}
                      \chunk{ABALO}
                    \end{bundle}
                  }
                \end{bundle}
              }
            \end{bundle}
          }
        \end{bundle}
      }
      \chunk{
        \begin{bundle}{m}
          \chunk{
            \begin{bundle}{i}
              \chunk{
                \begin{bundle}{g}
                  \chunk{
                    \begin{bundle}{o}
                      \chunk{AMIGO}
                    \end{bundle}
                  }
                \end{bundle}
              }
            \end{bundle}
          }
          \chunk{
            \begin{bundle}{o}
              \chunk{
                \begin{bundle}{r}
                  \chunk{AMOR}
                \end{bundle}
              }
            \end{bundle}
          }
        \end{bundle}
      }
    \end{bundle}
  }

  \chunk{
    \begin{bundle}{m}
      \chunk{
        \begin{bundle}{e}
          \chunk{
            \begin{bundle}{d}
              \chunk{
                \begin{bundle}{o}
                  \chunk{MEDO}
                \end{bundle}
              }
            \end{bundle}
          }
        \end{bundle}
      }
      \chunk{
        \begin{bundle}{u}
          \chunk{
            \begin{bundle}{d}
              \chunk{
                \begin{bundle}{o}
                  \chunk{MUDO}
                \end{bundle}
              }
            \end{bundle}
          }
        \end{bundle}
      }
    \end{bundle}
  }

    \chunk{
      \begin{bundle}{p}
        \chunk{
          \begin{bundle}{e}
            \chunk{PE}
            \chunk{
              \begin{bundle}{d}
                \chunk{
                  \begin{bundle}{r}
                    \chunk{
                      \begin{bundle}{a}
                        \chunk{PEDRA}
                      \end{bundle}
                    }
                  \end{bundle}
                }
              \end{bundle}
            }
          \end{bundle}
        }
        \chunk{
          \begin{bundle}{o}
            \chunk{
              \begin{bundle}{d}
                \chunk{
                  \begin{bundle}{r}
                    \chunk{
                      \begin{bundle}{e}
                        \chunk{PODRE}
                      \end{bundle}
                    }
                  \end{bundle}
                }
              \end{bundle}
            }
            \chunk{
              \begin{bundle}{b}
                \chunk{
                  \begin{bundle}{r}
                    \chunk{
                      \begin{bundle}{e}
                        \chunk{POBRE}
                      \end{bundle}
                    }
                  \end{bundle}
                }
              \end{bundle}
            }
          \end{bundle}
        }
      \end{bundle}
    }
\end{bundle}
\]
}
%vskip 1cm
Deve ser possvel inserir palavras (palavra e definio) e procurar a
definio de determinada palavra. O programa dever permitir a
gravao do dicionrio em disco para carregamento posterior.
\end{quote}

\section{O que se pretende}
Considere o programa em C dado em anexo (pg.\pageref{sec:C}) que  fornecido
como resposta aos requisitos acima. O que se pretende neste trabalho  a
converso (inverso) desse programa em C para \Haskell, por forma a
evidenciar uma comparao entre as capacidades expressivas
das duas linguagens. H que ter em conta os pontos seguintes:
\begin{itemize}
\item	
O programa em \Haskell\ a desenvolver dever ser o
mais simples possvel, tanto em tamanho como em complexidade.
Contudo,
uma vez compilado pelo GHC, deve produzir o mesmo efeito que o programa C de
que se partiu.
\item	
Dever ainda ser suficientemente paramtrico de modo a que,
para diferentes instanciaes de tipos (polimorfismo),
possa representar outros tipos de problemas.
Uma situao que dever obriatoriamente ser considerada  a sua instanciao
por forma a % que \emph{dictionary} possa
representar sistemas de ficheiros hierrquicos do tipo Unix ou Windows.
\item	
Podero ser definidas funes auxiliares ou outras desde que o resultado
seja cdigo \Haskell\ permanea elegante e legvel.
\end{itemize}
Tal como  habitual nos trabalhos desta disciplina,
fornece-se de seguida um kit para arranque do projecto.
O enunciado concluir-se- com sugestes para valorizao do trabalho a realizar.

\section{Material fornecido como kit para o projecto}
Entre na pgina da disciplina e descarregue,
descomprimindo-o (\eg\ via \texttt{unzip}), o ficheiro
\mpiMP{\texttt{mpi0203mp.zip}} que contm o respectivo material pedaggico.
%
Para alm de outros ficheiros relevantes para a disciplina, dever obter:
\begin{enumerate}
\item	\texttt{mpi0203t1.lhs} - trata-se do ficheiro que est a ler neste
momento, escrito em \litp{literate} \Haskell. Isto significa que:
	\begin{itemize}
	\item	se o carregar no \Hugs, este interpretador carregar o cdigo
		\Haskell\ nele contido e interpret-lo-.
		Neste momento o nico cdigo \Haskell\ presente ,
		a ttulo de exemplo,
\begin{code}
		main = print("trabalho ainda por realizar")
\end{code}
	\item	se o processar via \LaTeX\ (ou PDF\LaTeX) obter este mesmo
		documento em \pdf{PDF}.
		Sugesto: experimente
\begin{verbatim}
       latex mpi0203t1.lhs
       dvips -o mpi0203t1.ps mpi0203t1
       ps2pdf mpi0203t1.ps
\end{verbatim}
		ou, mais simplesmente, 
		\texttt{pdflatex mpi0203t1.lhs}.

		Se no est habituado a \LaTeX: em \Linux, faz parte da
		distribuio standard e  s experimentar;
		em Windows, sugere-se a instalao de \miktex{MiK\TeX}
		(\texttt{http://www.miktex.org/}).
	\end{itemize}
\item	\texttt{mpi0203t1.sty} - trata-se de um ficheiro importado por
	\texttt{mpi0203t1.lhs}, contendo funes de processamento de texto
	expressas em sintaxe \LaTeX\ (como poder ver,  normal programar
	\emph{funcionalmente} em \LaTeX).
\item	\texttt{mpi0203t1.pdf} - trata-se do resultado do processamento de
	\texttt{mpi0203t1.lhs},
	fornecido para sua convenincia, caso no tenha \LaTeX\
	acessvel.
\end{enumerate}
	O trabalho consiste em editar o ficheiro \texttt{mpi0203t1.lhs},
	acrescentando-lhe no s texto seu (por exemplo, prembulo,
	concluses, detalhes de execuo, pistas para trabalho futuro, etc.)
	mas todo o cdigo \Haskell\ que vai desenvolver, introduzindo-o
	pela ordem que lhe parecer mais natural
	\footnote{Veja como o fazer inspeccionando o material pedaggico
		da disciplina em 2001/2, eg.\ \texttt{mpi0102t1.lhs}.
	}.

\section{Sugestes para Valorizao}
\begin{itemize}
\item	Construa uma soluo hbrida em que parte das funes esto
	em C (eg.\ \texttt{main}) e as outras esto em \Haskell.
\item	Investigue sobre literate programming em C e adapte
	\texttt{mpi0203t1.lhs} por forma a poder ser submetido directamente
	ao seu compilador de C.
\item	Inclua no polimorfismo da sua soluo dois tipos de dados
	conhecidos: rvores de deciso e rvores genealgicas
	(ver trabalhos anteriores desta disciplina).
\end{itemize}

\appendix

\section*{Anexo}\label{sec:C}

\small
\begin{verbatim}
#define _GNU_SOURCE

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

typedef struct _cell_ {
  char letter;
  char *description;
  struct _cell_ *child, *next;
} Cell;

Cell* new_cell(void) {
  Cell *tree;
  tree = (Cell*)malloc(sizeof(Cell));
  tree->letter = ' ';
  tree->description = NULL;
  tree->child = NULL;
  tree->next = NULL;
  return tree;
}

void list_(Cell *tree, char* prefix) {
  if (tree) {
    char *p;
    if (tree->description) {
      printf("%s%c: %s\n", prefix, tree->letter, tree->description);
    }
    /* NOTE: THIS LINE ONLY WORKS ON LINUX/GCC */
    asprintf(&p, "%s%c", prefix, tree->letter);
    list_(tree->child, p);
    free(p);
    list_(tree->next, prefix);
  }
}

void list(Cell *tree) {
  list_(tree, "");
}

char* search(Cell *tree, char *word) {
  if (!word || !tree || *word == '\0') return NULL;
  if (tree->letter == *word) {
    if (*(word+1) == '\0') {
      return tree->description;
    } else {
      return search(tree->child, word+1);
    }
  } else {
    return search(tree->next, word);
  }
}

Cell* add(Cell *tree, char *word, char *description) {
  if (!word || *word == '\0') return NULL;
  if (tree) {
    if (tree->letter == *word) {
      tree->child = add(tree->child, word+1, description);
      if (!tree->child) tree->description = strdup(description);
    } else {
      if (tree->letter < *word) {
	Cell *cell = new_cell();
	cell->letter = *word;
	cell->child = add(cell->child, word+1, description);
	cell->next = tree;
	tree = cell;
      } else {
	tree->next = add(tree->next, word, description);
      }
    }
  } else {
    tree = new_cell();
    if (!tree) return NULL;
    tree->letter = *word;
    tree->child = add(tree->child, word+1, description);
    if (!tree->child) {
      tree->description = strdup(description);
    }
  }
  return tree;
}


int main(void) {
  Cell *tree;

  tree = NULL;

  tree = add(tree, "dormir", "acto de ressonar :)");
  tree = add(tree, "dormirei", "forma do verbo dormir");
  tree = add(tree, "dorminhoco", "aquele que dorme muito");

  list(tree);
  return 0;
}
\end{verbatim}

\end{document}

