
\documentclass{article}

\usepackage{mpi0203}
\usepackage{a4}

\title{2 Trabalho Prtico}

\author{
	\mpi{Mtodos de Programao I}
	\\
	\lesi{LESI}/\lmcc{LMCC}
	\\ Universidade do Minho
}


\date{Ano Lectivo de 2002/2003}

\begin{document}
\maketitle

\section{Prembulo}

Este trabalho deve ser realizado por grupos com um mximo de trs alunos.
O relatrio do trabalho deve ser entregue at ao dia
\pisca{26 de Novembro de 2002} na Recepo do \dium\ (ext.\ 4430).
Simultaneamente, dever ser realizada a entrega electrnica,
de acordo com as instrues que sero muito brevemente divulgadas
na pgina da disciplina (WWW).

\section{O problema}
Neste trabalho pretende-se explorar a capacidade expressiva do conceito de \emph{mnada} em Haskell e do mecanismo de \emph{classes} da linguagem. O tema escolhido para esse efeito  o da construo de uma pequena calculadora de \emph{expresses aritmticas} tipo \texttt{bc} (faa \texttt{man bc} numa shell em Linux para saber do que se trata). Essa calculadora dever, em modo de comando,
\begin{itemize}
\item	
validar uma expresso aritmtica, que pode conter variveis como,
por exemplo \texttt{2 * (x + 1)}
\item
convert-la para cdigo mquina
\item interpretar de imediato esse cdigo, produzindo como resultado o valor da expresso dada.
\end{itemize}
O cdigo mquina escolhido  o MSP,
um assembler muito simples cujo manual de utilizao est disponvel.

Tal como  habitual nos trabalhos desta disciplina,
fornece-se de seguida um kit para arranque do projecto.
Este enunciado concluir-se- com sugestes para valorizao do trabalho a realizar.

\section{Material fornecido como kit para o projecto}
Entre na pgina da disciplina e descarregue,
descomprimindo-o (\eg\ via \texttt{unzip}), o ficheiro
\mpiMP{\texttt{mpi0203mp.zip}} que contm o respectivo material pedaggico.
%
Para alm de outros ficheiros relevantes para a disciplina, dever obter:
\begin{enumerate}
\item	\texttt{mpi0203t2.lhs} - trata-se do ficheiro que est a ler neste
momento, escrito em \litp{literate} \Haskell. Isto significa que:
	\begin{itemize}
	\item	se o carregar no \Hugs, este interpretador carregar o cdigo
		\Haskell\ nele contido e interpret-lo-.
		Sugesto: invoque o \Hugs\ e experimente
		\texttt{:l mpi0203t2.lhs}.
		Uma vez iniciada a sesso, escreva
\begin{verbatim}
       Main> exp2msp "2 * ( 3 + 4 )"
\end{verbatim}
		Dever obter a resposta
\begin{verbatim}
       PUSH 2
       PUSH 3
       PUSH 4
       ADD
       MUL
\end{verbatim}


	\item	se o processar via \LaTeX\ (ou PDF\LaTeX) obter este mesmo
		documento em \pdf{PDF}.
		Sugesto: experimente
\begin{verbatim}
       latex mpi0203t2.lhs
       dvips -o mpi0203t2.ps mpi0203t2
       ps2pdf mpi0203t2.ps
\end{verbatim}
		ou, mais simplesmente,
\begin{verbatim}
       pdflatex mpi0203t2.lhs
\end{verbatim}
		Se no est habituado a \LaTeX: em \Linux, faz parte da
		distribuio standard e  s experimentar;
		em Windows, sugere-se a instalao de \miktex{MiK\TeX}
		(\texttt{http://www.miktex.org/}).
	\end{itemize}
\item	\texttt{mpi0203.sty} - trata-se de um ficheiro importado por
	\texttt{mpi0203t2.lhs}, contendo funes de processamento de texto
	expressas em sintaxe \LaTeX\ (como poder ver,  normal programar
	\emph{funcionalmente} em \LaTeX).
\item	\texttt{mpi0203t2.pdf} - trata-se do resultado do processamento de
	\texttt{mpi0203t2.lhs},
	fornecido para sua convenincia, caso no tenha \LaTeX\
	acessvel.
\item	\texttt{MonadicPComb.hs} - mdulo auxiliar de reconhecimento
	sinttico.
\item	\texttt{MSPLPMAN.pdf} - manual de MSP.
\end{enumerate}
	O trabalho consiste em editar o ficheiro \texttt{mpi0203t2.lhs},
	acrescentando-lhe no s texto seu (por exemplo, prembulo,
	concluses, detalhes de execuo, pistas para trabalho futuro, etc.)
	mas todo o cdigo \Haskell\ que vai desenvolver, introduzindo-o
	pela ordem que lhe parecer mais natural.

\section{O que se pretende}
Comece por analisar o cdigo Haskell dado em anexo (pg.\pageref{sec:C}),
que  fornecido como primeira abordagem aos requisitos do trabalho.

Repare que o tradutor \texttt{exp2msp} est dividido em duas partes.
Em primeiro lugar o reconhecedor de expresses (parser) que,
baseado em mnadas, gera a rvore sinttica da cada expresso ou um erro
sinttico (seco \ref{sec:exp2msp}).
Em segundo lugar, a converso para MSP (seco \ref{sec:MSP}).
Esta  feita de forma subtil declarando o tipo \texttt{Exp} de tais rvores
sintticas como instncia da classe \texttt{Show}.
Assim, basta por exemplo escrever
\begin{verbatim}
       Main> exp2msp "2 * (x + 1)"
\end{verbatim}
que a correspondente sequncia de instrues MSP
 de imediato dada pelo \texttt{show} do resultado:
\begin{verbatim}
       PUSH 2
       LOAD "x"
       PUSH 1
       ADD
       MUL
\end{verbatim}

Note-se que estas instrues no so interpretadas.
Ora o que se pretende  pass-las a um interpretador de MSP por forma
a obter como resultado o \emph{valor} da expresso dada.
Assim, h que:
\begin{itemize}
\item
	Mudar a gerao de cdigo de forma a produzir no uma \emph{string}
	(como est a ser feito agora) mas uma lista de instrues a passar a um
	interpretador de MSP.
\item
	Construir esse interpretador como uma mquina mondica baseado na mnada
	de estado. Neste contexto, a interpretao de uma lista de instrues
	MSP pode ser realizada directamente com \texttt{sequence}.
\item
	Enriquecer o parser (e respectivo tipo das rvores) para tratar
	atribuies e sequenciao, eg.\ \texttt{x = 3 ; 2 * (x + 1)}.
\end{itemize}
Ser conveniente conhecer bem MSP, pelo que se recomenda a leitura do
respectivo manual de utilizao, fornecido no kit do projecto.
Para mais informao,
poder ser ainda explorado o \textsc{WinMSP}, um IDE para MSP desenvolvido
para Windows disponvel a partir de
\texttt{http://www.ipb.pt/\~{}rufino/past.html}.

\section{Sugestes para Valorizao}
\begin{itemize}
\item
	Estender o processador de expresses por forma a emular
	mais fielmente a shell \texttt{bc}
	\emph{(arbitrary precision calculator language)} da GNU.
\item
	Enriquecer o estado do interpretador de MSP com informao extra para
	efeitos de debug (buscar inspirao em \textsc{WinMSP})
\item
	Tornar o parser menos permissivo (por exemplo, \texttt{"x y"}
	 traduzido em \texttt{LOAD "x"}, quando deveria dar erro sinttico).
\end{itemize}

\appendix

\section{Anexo}\label{sec:C}
O cdigo Haskell fornecido neste anexo  baseado no mdulo
\begin{code}
import MonadicPComb
\end{code}
que dever ser cuidadosamente estudado.

\subsection{Syntaxe abstracta para expresses aritmticas}
\begin{code}
type ExpArit = Exp String Int BArit UArit
data BArit = Mais | Menos | Div | Mult
data UArit = Simetrico | Inverso
\end{code}

\noindent
onde

\begin{code}
data Exp vars values bop uop
     = C values
     | V vars
     | Bop (Exp vars values bop uop) bop (Exp vars values bop uop)
     | Uop uop (Exp vars values bop uop)
\end{code}

\subsection{Sintaxe concreta para expresses aritmticas}
\begin{verbatim}
{- Gramatica das expressoes aritmeticas

   ExpArit = Termo  | Termo + ExpArit | Termo  - ExpArit
   Termo  = Factor | Factor * Termo | Factor / Termo
   Factor = ( ExpArit ) | - Factor | Constante | Variavel
-}
\end{verbatim}

\subsection{Processador (mondico) da sintaxe concreta para expresses
	    aritmticas} \label{sec:exp2msp}
Consiste no comando

\begin{code}
exp2msp = parse parseExpArit
\end{code}

\noindent
o qual se baseia na funo de parsing

\begin{verbatim}
parse :: Parse a -> String -> Error a
\end{verbatim}

\noindent
definida em \texttt{MonadicPComb.hs},
a qual recebe como primeiro argumento o parser \texttt{parseExpArit}
que se segue:

\paragraph{Parser de Expresses}

\begin{code}

parseExpArit = do { f1 <- parseTermo ;
                    try [ (do { parseConst "+" ;
                                f2 <- parseExpArit ;
                                return (Bop f1 Mais f2) }
                        ),(do { parseConst "-" ;
                                f2 <- parseExpArit ;
                                return (Bop f1 Menos f2) }
                        ),(return f1)]
                  }
\end{code}

\paragraph{Parser de Termos}

\begin{code}

parseTermo = do { p1 <- parseFactor ;
                   try [ (do { parseConst "*" ;
                               p2 <- parseTermo ;
                               return (Bop p1 Mult p2) }
                       ),(do { parseConst "/" ;
                               p2 <- parseTermo ;
                               return (Bop p1 Div p2) }
                       ),(return p1)]
                 }

\end{code}

\paragraph{Parser de Factores}

\begin{code}

parseFactor = try [ (parsePCurvos parseExpArit
                   ),(do { parseConst "-" ;
                           p <- parseFactor ;
                           return (Uop Simetrico p)}
                   ),(do { n <- parseInt ;
                           return (C n)}
                   ),(do { v <- parseString ;
                           return (V v)}
                     )]
\end{code}

\subsection{Gerao de cdigo MSP (via Show)}	\label{sec:MSP}

\begin{code}
instance (Show a, Show b, Show c, Show d) => Show (Exp a b c d) where
  showsPrec n (C v) =
         showString "PUSH " . showsPrec n v . showLine ""
  showsPrec n (V v) =
         showString "LOAD " . showsPrec n v . showLine ""
  showsPrec n (Bop e1 b e2) = showsPrec n e1 .
                              showsPrec n e2 .
                              showsPrec n b
  showsPrec n (Uop u e) = showsPrec n e . showsPrec n u
\end{code}

\begin{code}
instance Show UArit where
   showsPrec _ Simetrico = showLine "SSIGN"
   showsPrec _ Inverso = showLine "INV"

instance Show BArit where
   showsPrec _ Mais = showLine "ADD"
   showsPrec _ Menos = showLine "SUBT"
   showsPrec _ Div = showLine "DIV"
   showsPrec _ Mult = showLine "MUL"
\end{code}

\end{document}

