
\documentclass{article}

\usepackage{mpi0203}
\usepackage{a4}
\usepackage{trees}

\title{3 Trabalho Prtico}

\author{
	\mpi{Mtodos de Programao I}
	\\
	\lesi{LESI}/\lmcc{LMCC}
	\\ Universidade do Minho
}


\date{Ano Lectivo de 2002/2003}

\begin{document}
\maketitle

\section{Prembulo}

Este trabalho deve ser realizado por grupos com um mximo de trs alunos.
O relatrio do trabalho deve ser submetido electronicamente at ao dia
\pisca{10 de Janeiro de 2003}, de acordo com as instrues divulgadas na
pgina da disciplina (WWW).
Simultaneamente, dever ser realizada a entrega de uma cpia em papel
na Recepo do \dium\ (ext.\ 4430).

\section{O problema}
Neste trabalho pretende-se explorar a capacidade expressiva dos tipos indutivos em Haskell para representarem situaes da vida real. O tema escolhido para esse efeito  o da composio e formatao de um jornal electrnico, com notcias, imagens, etc., a ser publicado em formato HTML calculado a partir de uma sua descrio abstracta em Haskell.

Tal como  habitual nos trabalhos desta disciplina,
fornece-se de seguida um kit para arranque do projecto.
Este enunciado concluir-se- com sugestes para valorizao do trabalho a realizar.

\section{Material fornecido como kit para o projecto}
Entre na pgina da disciplina e descarregue,
descomprimindo-o (\eg\ via \texttt{unzip}), o ficheiro
\mpiMP{\texttt{mpi0203mp.zip}} que contm o respectivo material pedaggico.
%
Para alm de outros ficheiros relevantes para a disciplina, dever obter:
\begin{enumerate}
\item	\texttt{mpi0203t3.lhs} - trata-se do ficheiro que est a ler neste
momento, escrito em \litp{literate} \Haskell. Isto significa que:
	\begin{itemize}
	\item	se o carregar no \Hugs, este interpretador carregar o cdigo
		\Haskell\ nele contido e interpret-lo-.
		Sugesto: invoque o \Hugs\ e experimente
		\texttt{:l mpi0203t3.lhs}.
		Uma vez iniciada a sesso, escreva
\begin{verbatim}
       Main> printJournal example
\end{verbatim}
		Dever obter a resposta
\begin{verbatim}
       Output HTML written into file `journal.html'
\end{verbatim}
	Poder encontrar o ficheiro \texttt{journal.html} na sua directoria
	de trabalho, onde a aplicao o gravou.
	Se o abrir no seu browser preferido, verificar
	que se trata de um arremedo de pgina de um jornal electrnico.

	\item	se o processar via \LaTeX\ (ou PDF\LaTeX) obter este mesmo
		documento em \pdf{PDF}.
		Sugesto: experimente
\begin{verbatim}
       latex mpi0203t3.lhs
       dvips -o mpi0203t3.ps mpi0203t3
       ps2pdf mpi0203t3.ps
\end{verbatim}
		ou, mais simplesmente,
\begin{verbatim}
       pdflatex mpi0203t3.lhs
\end{verbatim}
		Se no est habituado a \LaTeX: em \Linux, faz parte da
		distribuio standard e  s experimentar;
		em Windows, sugere-se a instalao de \miktex{MiK\TeX}
		(\texttt{http://www.miktex.org/}).
	\end{itemize}
\item	\texttt{mpi0203.sty} - trata-se de um ficheiro importado por
	\texttt{mpi0203t3.lhs}, contendo funes de processamento de texto
	expressas em sintaxe \LaTeX\ (como poder ver,  normal programar
	\emph{funcionalmente} em \LaTeX).
\item	\texttt{mpi0203t3.pdf} - trata-se do resultado do processamento de
	\texttt{mpi0203t3.lhs},
	fornecido para sua convenincia, caso no tenha \LaTeX\
	acessvel.
\item	\texttt{journal.html} - o ficheiro acima referido,
	fornecido para sua convenincia, caso no consiga
	--- por qualquer motivo --- produzi-lo.
\item	Vrios ficheiros \texttt{*.jpg} - imagens usadas na composio do
	jornal exemplo.
\end{enumerate}
	O trabalho consiste em editar o ficheiro \texttt{mpi0203t3.lhs},
	acrescentando-lhe no s texto seu (por exemplo, prembulo,
	concluses, detalhes de execuo, pistas para trabalho futuro, etc.)
	mas todo o cdigo \Haskell\ que vai desenvolver, introduzindo-o
	pela ordem que lhe parecer mais natural.

\section{Anlise do kit do projecto}
Comece por analisar o cdigo Haskell dado em anexo (pg.\pageref{sec:C}),
que  fornecido como primeira abordagem aos requisitos do trabalho.
Nele encontra o tipo $Sheet$ (=pgina de jornal) que  baseado num tipo
indutivo $X$, cuja estrutura de base  semelhante a
\begin{eqnarray*}
	X	&\iso& A + B  X
\end{eqnarray*}
e que exprime a partio de um rectngulo (a pgina tipogrfica)
em vrios subrectngulos
(as caixas tipogrficas a encher com texto ou imagens),
segundo um processo de partio binria, na horizontal ou na vertical.
O tipo $Mode$ especifica quatro variantes de partio. O seu argumento dever
ser um nmero de 0 a 1, indicando a fraco da altura (ou da largura) em que o
rectngulo  dividido, a saber:
\begin{itemize}
\item \texttt{Hr i} ---  partio horizontal, medindo $i$ a partir da direita
\item \texttt{Hl i} ---  partio horizontal, medindo $i$ a partir da esquerda
\item \texttt{Vt i} ---  partio vertical, medindo $i$ a partir do topo
\item \texttt{Vb i} ---  partio vertical, medindo $i$ a partir da base
\end{itemize}

Por exemplo, a partio dada na figura da pgina \pageref{fig:1}
corresponde  partio de um rectngulo $780  960$ de acordo
com a seguinte rvore de parties:
%
\begin{eqnarray*}
\mbox{
\tree{$Hl(0.41)$}
\subtree{$Vt(0.48)$}
\leaf{$c$}
\subtree{$Vt(0.36)$}
\leaf{$d$}
\leaf{$e$}
\endsubtree
\endsubtree
\subtree{$Vb(0.6)$}
\leaf{$a $}
\leaf{$ b$}
\endsubtree
\endtree
}
\end{eqnarray*}

\begin{figure}
\begin{center}
\unitlength=.05mm
\special{em:linewidth 0.2pt}
\begin{picture}(780.00,960.00)
\put(0.00,0.00){\makebox(320,320)[cc]{$e$}}
\put(0.00,0.00){\line(1,0){320.00}}
\put(0.00,0.00){\line(0,1){320.00}}
\put(0.00,320.00){\line(1,0){320.00}}
\put(320.00,0.00){\line(0,1){320.00}}
\put(0.00,320.00){\makebox(320,180)[cc]{$d$}}
\put(0.00,320.00){\line(0,1){180.00}}
\put(0.00,500.00){\line(1,0){320.00}}
\put(320.00,320.00){\line(0,1){180.00}}
\put(0.00,500.00){\makebox(320,460)[cc]{$c$}}
\put(0.00,500.00){\line(0,1){460.00}}
\put(0.00,960.00){\line(1,0){320.00}}
\put(320.00,500.00){\line(0,1){460.00}}
\put(320.00,0.00){\makebox(460,580)[cc]{$ b$}}
\put(320.00,0.00){\line(1,0){460.00}}
\put(320.00,0.00){\line(0,1){580.00}}
\put(320.00,580.00){\line(1,0){460.00}}
\put(780.00,0.00){\line(0,1){580.00}}
\put(320.00,580.00){\makebox(460,380)[cc]{$a $}}
\put(320.00,580.00){\line(0,1){380.00}}
\put(320.00,960.00){\line(1,0){460.00}}
\put(780.00,580.00){\line(0,1){380.00}}
\end{picture}
\end{center}
\label{fig:1}
\end{figure}

As caixas delineadas por uma partio (como a dada acima) correspondem a
folhas da rvore de partio e podem conter texto ou imagens.  o que
se verifica no objecto \texttt{example} da seco \ref{sec:test_data}
que, processado por \texttt{sheet2html} (seco \ref{sec:html})
vem a produzir o ficheiro \texttt{journal.html}.

\section{O que se pretende}
Infere-se da anlise da seco anterior que o cdigo Haskell fornecido
como kit para arranque deste trabalho no est suficientemente estruturado
em termos dos combinadores \texttt{cata}, \texttt{ana}, \texttt{hylo}
estudados nesta disciplina.
%
O que se pretende , ento:
\begin{enumerate}
\item	A construo de uma biblioteca pointfree
	\footnote{%
		A desenvolver de forma anloga a outras bibliotecas que
		conhece (\eg\ \texttt{BTree.hs}, etc).
}
	com base na qual o processamento (pointwise) j disponvel
	possa ser redefinido.
\item	A evoluo da biblioteca anterior para uma outra que permita
	parties $n$-rias (para \emph{qualquer} $n$ finito)
	e no apenas binrias
	\footnote{
		Repare que  a falta desta capacidade expressiva
		que origina, no kit actual, a definio das funes
		auxiliares  da seco \ref{sec:faux}, por exemplo.
	}.
\item	Uma parametrizao adequada da biblioteca anterior por forma
	a acomodar no apenas texto corrido e imagens, mas tambm links
	e fonts.
\item	Funcionalidade adicional para ampliao/reduo de caixas tipogrficas,
        mudanas de font, etc.
\end{enumerate}

\section{Sugestes para Valorizao}
Qualquer contribuio na direco das questes seguintes:
\begin{enumerate}
\item
	 Como controlar fonts, tamanhos de imagens e impedir a sua distoro?
\item
	 Como produzir texto formatado?
\item
	 Quo prtica  esta maneira de produzir um layout de jornal?
	 Que outras estruturas indutivas podem ser usadas para o mesmo efeito?
	\footnote{Havendo tempo, pode ser til a consulta da referncia
	{\em	% J.N.\ Oliveira.
		CAD Tool Extension for Formal Building Description Language.
		\htmladdnormallink{ Advances in Engineering Software}{
http://www.elsevier.nl/inca/publications/store/4/2/2/9/1/1/index.htt
		}}, 29(7-9):571--586, 1998.}
\item	Sofisticao grfica: elaborar o HTML produzido em termos de design
	por forma a aproximar o resultado de \texttt{printJournal}
	de um jornal electrnico real.
\end{enumerate}

\appendix

\section{Anexo}\label{sec:C}
O cdigo Haskell fornecido neste anexo  baseado no mdulo
\begin{code}
import IO
\end{code}

\subsection{Tipos de dados}

\begin{code}
data X a b i = Leaf (Unit a b) | Node (Mode i) (X a b i) (X a b i) deriving Show

data Sheet a b i = Rect (Frame i) (X a b i) deriving Show

data Mode i = Hr i | Hl i | Vt i | Vb i deriving Show

data Frame i = Frame i i deriving Show

-- leafs info

data Unit a b = Image a
              | Text b deriving Show
\end{code}

\subsection{Funes da API (IO)}
A API (=Application Program Interface) deste mdulo consiste nas funes
seguintes:
\begin{code}
printJournal :: Sheet String String Double -> IO ()
printJournal = write . sheet2html

write :: String  -> IO ()
write s = do writeFile "journal.html" s
             putStr "Output HTML written into file `journal.html'"
\end{code}

\subsection{Gerao de HTML} \label{sec:html}

\begin{code}
sheet2html (Rect (Frame w h) y) = htmlbegin ++ x2html y (w,h) ++ htmlend

x2html :: X String String Double -> (Double, Double) -> String
x2html (Leaf (Image img)) (w,h)= "<img src=\"" ++
                              img ++ 
                              "\" width  =\"" ++
                              show(w) ++ 
                              "\" height =\"" ++
                              show(h) ++ 
                              "\">"
x2html (Leaf (Text txt)) _ = txt
x2html (Node (Vt i) x1 x2) (w,h) = "<table cellpadding=\"0\" width=\"" ++ 
                                       show(w) ++ 
                                       "\" height =\"" ++
                                       show(h) ++ 
                                       "\">\n<tr>\n<td width=\"" ++
                                       show(w) ++ 
                                       "\" height =\"" ++
                                       show(h*i) ++ 
                                       "\">\n" ++ 
                                       x2html x1 (w, h*i) ++
                                       "\n</td>\n</tr>" ++
                                       "\n<tr>\n<td width=\"" ++
                                       show(w) ++ 
                                       "\" height =\"" ++
                                       show(h*(1-i)) ++ 
                                       "\">\n" ++
                                       x2html x2 (w, h*(1-i)) ++
                                       "\n</td>\n</tr>\n</table>"
x2html (Node (Hl i) x1 x2) (w,h) = "<table cellpadding=\"0\" width=\"" ++ 
                                       show(w) ++ 
                                       "\" height =\"" ++
                                       show(h) ++ 
                                       "\">\n<tr>\n<td width=\"" ++
                                       show(w*i) ++ 
                                       "\" height =\"" ++
                                       show(h) ++ 
                                       "\">\n" ++ 
                                       x2html x1 (w*i, h) ++
                                       "\n</td>\n<td width=\"" ++
                                       show(w*(1-i)) ++ 
                                       "\" height =\"" ++
                                       show(h) ++ 
                                       "\">\n" ++
                                       x2html x2 (w*(1-i), h) ++
                                       "\n</td>\n</tr>\n</table>"                                        
x2html (Node (Vb i) x1 x2) m = x2html (Node (Vt (1 - i)) x1 x2) m
x2html (Node (Hr i) x1 x2) m = x2html (Node (Hl (1 - i)) x1 x2) m

htmlbegin = "<html>\n" ++ 
            "<head>\n" ++ 
            "<title>MP-I/0203: Sheet2HTML</title>\n" ++
            "</head>\n\n" ++ 
            "<body BGCOLOR=\"#F4EFD8\">\n" ++
            "<div align=\"center\">\n"

htmlend = "\n</div>\n</body>" 
\end{code}

\subsection{Funes auxiliares} \label{sec:faux}

\begin{code}
twoVtImg a b = Node (Vt 0.5) (Leaf (Image a)) (Leaf (Image b))

fourInArow a b c d =
	Node (Hl 0.5)
	  (Node (Hl 0.5) (Leaf (Text a)) (Leaf (Text b)))
	  (Node (Hl 0.5) (Leaf (Text c)) (Leaf (Text d)))
\end{code}

\subsection{Dados para teste} \label{sec:test_data}

\begin{code}
example :: (Fractional i) => Sheet String String i
example = 
   Rect (Frame 420 450)
    (Node (Vt 0.01)
      (Node (Vt 0.1)
         (Leaf (Image "dn-logo.jpg"))
         (fourInArow "5-feira, 12 de Dezembro 2002" "Ano 1" "Nr. 1" "Suplemento MP-I/0203."))
      (Node (Vt 0.55)
	  (Node (Hl 0.65)
              (Leaf (Text 
                 "PORTO - A chegada do Metro. A Linha Azul vai dar inicio ao metro na regio do Porto. A primeira fase estar concluda em 2004. Nesta altura j estaro a funcionar quatro linhas e consolidado um projecto que comeou em Setembro de 1989. So quatro linhas que constituem a rede do Metro do Porto. A extenso dever atingir cerca de 70 quilmetros, dos quais sete so em tnel. As linhas so Senhor de Matosinhos/Campanh; Pvoa de Varzim/Campanh, Trofa/Campanh e Hospital de S.Joo/Santo Ovdeo. At ao final de 2003 estar concluda a Linha Azul e entram em funcionamento parcial a Linha B (Vermelha) entre Campanh e Pedras Rubras e a Linha C (Verde) entre a Trindade e a Maia. A primeira fase do Metro ficar concluda em 2004 e vai passar pelos concelhos do Porto, Matosinhos, Maia, Vila do Conde, Pvoa de Varzim, Trofa e Gaia."))
              (Leaf (Image
		  "mapa_metro.jpg")))
	  (Node (Hl 0.32)
              (twoVtImg
		  "manuel_oliveira_rt.jpg"
		  "manoel_de_oliveira_adn.jpg")
              (Leaf (Text 
	          "MANOEL DE OLIVEIRA - Patriarca do cinema portugus celebra 94 anos.  Quando era jovem sonhou ser actor. Os caminhos do cinema levaram-no a ser o realizador portugus mais consagrado no estrangeiro. Elogiada por uns e criticada por outros, a obra de Manoel de Oliveira  um smbolo da histria do cinema nacional.   considerado por alguns como o patriarca do cinema portugus e na sua carreira teve sempre como objectivo primordial oferecer momentos de prazer visual e espiritual ao pblico, como afirmou em diversas entrevistas.  Manoel de Oliveira completa quarta-feira 94 anos. Ainda assim, continua a fazer um filme por ano, uma mdia que iniciou na dcada de noventa.  A rodagem de Um Filme falado, a exibir em 2003, j est a terminar.")))))
\end{code}

\end{document}
